//cv graph.cpp maxflow.cpp graph.h block.h alpha_real.cpp -o test0115
//./real   뺹β褫()

#include <stdio.h>
#include <stdlib.h>
#include <cv.h>
#include <highgui.h>
#include "graph.h"
#include <vector>
#define WINDOW_SIZE 5
#define INFTY 100000
#define DISPMAX 81
#define C 15

std::vector< std::vector< int > > Aarray;  
IplImage *leftI = 0;
IplImage *rightI = 0;
int width = 0;
int height = 0;

///////////////////////////////////////////////////////////////////////////////////////
//ǡȴؿSAD
int Cost_sad(int I,int pos){

  int i,j;
  
  if( (pos<width*(WINDOW_SIZE/2)) || (pos>width*(height-(WINDOW_SIZE/2))) )   return 0;
  if( (pos%width-(WINDOW_SIZE/2) < 0) || (pos%width+(WINDOW_SIZE/2)>=width) ) return 0;
  
  int cost = 0;
  
  for( i = -(WINDOW_SIZE/2); i <= (WINDOW_SIZE/2); i++ ) 
    {
    for( j = -(WINDOW_SIZE/2); j <= (WINDOW_SIZE/2); j++ )
      {
      cost += abs((int)CV_IMAGE_ELEM(leftI, uchar, pos/width+j, pos%width+i) -
		  (int)CV_IMAGE_ELEM(rightI, uchar, pos/width+j, pos%width+i-I));
    }
  }

  return cost;

}

///////////////////////////////////////////////////////////////////////////////////////
//ֶᤤ٥
int near_label(int alpha,int I){
  int i;
  int imax = Aarray[alpha].size();
  int sub = 1000;
  int selectA = 0;
  for(i=0; i<imax; i++){
    if(sub>=abs(Aarray[alpha][i]-I))
      {
  	sub = abs(Aarray[alpha][i]-I);
  	selectA = Aarray[alpha][i];
      }
  }

  //fprintf(stderr,"A:%d\n",selectA);

  return selectA;
}

///////////////////////////////////////////////////////////////////////////////////////
//ࡼȤ
int V(int a, int b){

  return C*abs(a-b);
}


//***********************************************************************************//
int main(int argc,char *argv[]){
  char filename[256];
  if(argc != 4){
    fprintf(stderr,"Uage:beta left right A[num]\n");
    return -1;
  }
  //ɤ߹//////////////////////////////////////////////////////////
  if((leftI = cvLoadImage(argv[1], CV_LOAD_IMAGE_GRAYSCALE))==0||
     (rightI = cvLoadImage(argv[2], CV_LOAD_IMAGE_GRAYSCALE))==0)
    {
      fprintf(stderr,"ImageOpenError\n");
      return -1;
    }
  width =  leftI->width;
  height =  leftI->height;
  //fprintf(stderr,"w:%d h:%d\n",width, height);
  
  //A////////////////////////////////////////////////////////////////
  int i, j;
  int num  = atoi(argv[3]); 
  //fprintf(stderr,"%d\n",num);

  int a_num = (int)pow(2, num); 
  //fprintf(stderr,"%d\n",a_num);

  int a_what[a_num];
  for(i=0; i<a_num; i++){
    a_what[i] = i; 
    //fprintf(stderr,"%d\n",a_what[i]);
  }

  int a_max = num * 2;
  Aarray.resize(a_max);
  Aarray[0].resize(1);
  Aarray[0][0] = a_what[0];
  Aarray[1].resize(1);
  Aarray[1][0] = a_what[a_num/2];
  //fprintf(stderr,"A[0]{ %d }\n",Aarray[0][0]);
  //fprintf(stderr,"A[1]{ %d }\n",Aarray[1][0]);
  int countA= 2;
  int moge = 1;
//   for(i=2; i<a_max; i++){
//     Aarray[i].resize(moge);
//     //fprintf(stderr,"A[%d]{",i);
//     for(j=0; j<moge; j++){
//       Aarray[i][j] = a_what[(int)(((1+4*j)*a_num)/pow(2,countA))];
//       //fprintf(stderr," %d",Aarray[i][j]);
//     }
//     //fprintf(stderr," }\n");
//     i++;
//     Aarray[i].resize(moge);
//     //fprintf(stderr,"A[%d]{",i);
//     for(j=0; j<moge; j++){
//       Aarray[i][j] = a_what[(int)(((3+4*j)*a_num)/pow(2,countA))];
//       //fprintf(stderr," %d",Aarray[i][j]);
//     }
//     //fprintf(stderr," }\n");
//     moge *= 2;
//     countA++;
//   }



   
  /////////////////////////////////////////////////////////////////////////
  //////////////////////////////եå///////////////////////////////
  
  clock_t start, end; //޴ؿѿ
  int I[width*height];
  //
  for(i=0; i<(width*height); i++){
    I[i] = 0;
  }


  int E = 100000000;
  int Et; 
  int alpha;
  int success;
  int ap, aq, bp, bq;
  int asub, bsub;
  int epap, eqaq;
  int flow;


  start = clock();

  for(j=0; j<10000; j++){
    success = 0;
    //for(alpha=0; alpha<a_max; alpha++){
    for(alpha=0; alpha<a_num; alpha++){
      //fprintf(stderr,"alpha = %d\n",alpha);
      
      typedef Graph<int,int,int> GraphType;
      GraphType *g = new GraphType(4*width*height,6*width*height);
      
      ////////////////////////////////////
      //   󥯴֤Υ //
      ////////////////////////////////////
      //
      //fprintf(stderr,"I%d\n",alpha);
      for(i=0; i<width*height; i++)
	{
	  g -> add_node();
	  //g -> add_tweights(i,Cost_sad(I[i],i),Cost_sad(near_label(alpha,I[i]),i));
	  g -> add_tweights(i,Cost_sad(I[i],i),Cost_sad(alpha,i));
	}
      
      //fprintf(stderr,"YokoA%d\n",alpha);
      //a
      for(i=0; i<width*height; i++){
	if(i%width != width-1){
	  //fprintf(stderr,"b%d\n",i);
	  g -> add_node();
	  // ap = near_label(alpha,I[i]);
// 	  aq = near_label(alpha,I[i+1]);
// 	  bp = I[i];
// 	  bq = I[i+1];
// 	  asub = V(ap,aq);
// 	  bsub = V(bp,bq);
// 	  g -> add_tweights(i-(i/width)+(width*height),bsub,asub);
// 	  if(bsub <= asub){
// 	    if((V(ap,bq)-V(bp,bq)) >= 0)
// 	      {epap = (V(ap,bq)-V(bp,bq));}
// 	    else
// 	      {epap = 0;}
// 	    if((V(bp,aq)-V(bp,bq)) >= 0)
// 	      {eqaq = (V(bp,aq)-V(bp,bq));}
// 	    else
// 	      {eqaq = 0;}
// 	    g -> add_edge(i,i-(i/width)+(width*height),epap,INFTY);
// 	    g -> add_edge(i-(i/width)+(width*height),i+1,INFTY,eqaq);
// 	  }
// 	  else{
// 	    if((V(bp,aq)-V(ap,aq)) >= 0)
// 	      {epap = (V(bp,aq)-V(ap,aq));}
// 	    else
// 	      {epap = 0;}
// 	    if((V(ap,bq)-V(ap,aq)) >= 0)
// 	      {eqaq = (V(ap,bq)-V(ap,aq));}
// 	    else
// 	      {eqaq = 0;}
// 	    g -> add_edge(i,i-(i/width)+(width*height),INFTY,epap);
// 	    g -> add_edge(i-(i/width)+(width*height),i+1,eqaq,INFTY);
// 	  }
	  g -> add_tweights(i-(i/width)+(width*height),V(I[i],I[i+1]),V(alpha,alpha));
	  g -> add_edge(i,i-(i/width)+(width*height),V(I[i],alpha),V(I[i],alpha));
	  g -> add_edge(i-(i/width)+(width*height),i+1,V(I[i+1],alpha),V(I[i+1],alpha));
	  
	}
      }
      
      //fprintf(stderr,"TateA%d\n",alpha);
      //a
      for(i=0; i<width*(height-1); i++){
	if(i/width != height-1){
	  g -> add_node();
// 	  ap = near_label(alpha,I[i]);
// 	  aq = near_label(alpha,I[i+width]);
// 	  bp = I[i];
// 	  bq = I[i+width];
// 	  asub = V(ap,aq);
// 	  bsub = V(bp,bq);
// 	  g -> add_tweights(i+((2*width*height)-height),bsub,asub);
// 	  if(bsub <= asub){
// 	    if((V(ap,bq)-V(bp,bq)) >= 0)
// 	      {epap = (V(ap,bq)-V(bp,bq));}
// 	    else
// 	      {epap = 0;}
// 	    if((V(bp,aq)-V(bp,bq)) >= 0)
// 	      {eqaq = (V(bp,aq)-V(bp,bq));}
// 	    else
// 	      {eqaq = 0;}
// 	    g -> add_edge(i,i+((2*width*height)-height),epap,INFTY);
// 	    g -> add_edge(i+((2*width*height)-height),i+width,INFTY,eqaq);
// 	  }
// 	  else{
// 	    if((V(bp,aq)-V(ap,aq)) >= 0)
// 	      {epap = (V(bp,aq)-V(ap,aq));}
// 	    else
// 	      {epap = 0;}
// 	    if((V(ap,bq)-V(ap,aq)) >= 0)
// 	      {eqaq = (V(ap,bq)-V(ap,aq));}
// 	    else
// 	      {eqaq = 0;}
// 	    g -> add_edge(i,i+((2*width*height)-height),INFTY,epap);
// 	    g -> add_edge(i+((2*width*height)-height),i+width,eqaq,INFTY);
//       }

	  g -> add_tweights(i+((2*width*height)-height),V(I[i],I[i+width]),V(alpha,alpha));
	g -> add_edge(i,i+((2*width*height)-height),V(I[i],alpha),V(I[i],alpha));
	g -> add_edge(i+((2*width*height)-height),i+width,V(I[i+width],alpha),V(I[i+width],alpha));

	
	}
      }

      flow = g -> maxflow();
      Et = flow;

      if(E>Et){
	E = Et;
	fprintf(stderr,"Updata:E = %d\n",Et);
	for(i=0; i<width*height; i++)
	  {
	    if(g -> what_segment(i) == GraphType::SOURCE)
	      {
		/*󥯤ʤ饽*/
		//I[i] = near_label(alpha,I[i]);
		I[i] = alpha;
		//fprintf(stderr,"%d\n",I[i]);
	      }
	    else
	      {
		/*ʤ饷*/
		//fprintf(stderr,"%d\n",I[i]);
	      }
	  }
	success = 1;	
      }
      delete g;
    }
    if(success == 0){
      break;
    }
}

  end = clock();

  fprintf(stderr,"MaxFlow = %d\n", E);
  fprintf(stderr,"Time = %d[s]\n", (end - start)/CLOCKS_PER_SEC);
  ///////////////////////////
  //  եåȷ̤ȿ  //
  ///////////////////////////
  for(int i=0;i<width*height;i++){
    /*ʤ*/
    //cvSet2D(betaI,i/width,i%width,cvScalar(I[i]));
    /**/
    cvSet2D(rightI,i/width,i%width,cvScalar(255*I[i]/a_num));
  }
  
  /* ̤¸ */
  fprintf(stderr,"Please input OutputFileName<ex)AsizeWinsizeCsize.ppm>\n");
  scanf("%s", &filename);
  cvSaveImage(filename,rightI);
  
  cvReleaseImage(&leftI);
  cvReleaseImage(&rightI);
  return 0;
}




